#include <iostream.h>

class A
{
protected:
  int a;
public:
  A(){cout<<endl<<"A()";}
  A(int aa){a=aa; cout<<endl<<"A(int)";}
};

class B: public A
{
protected:
  int b;
public:
  B(){cout<<endl<<"B()";}
  B(int aa):b(a), A(aa) {b=b+1;cout<<endl<<"B(int)";}
};

class C: public A
{
public:
  C():A(){cout<<endl<<"C";}
};

class D: public B, public C
{
public:
  D():C(),B(){cout<<endl<<"D";}
  D(int a):C(),B(a){cout<<endl<<"D"<<' '<<B::a<<' '<<b;}
};

class BV: virtual public A
{
protected:
  int b;
public:
  BV():b(2),A(b){cout<<endl<<"BV";}
};

class CV: virtual public A
{
public:
  CV():A(){cout<<endl<<"CV";}
};

class DV: public BV, public CV
{
public:
  DV():CV(),BV(){cout<<endl<<"DV()";}
  DV(int aa):CV(),BV(),A(aa){cout<<endl<<"DV(int)"<<' '<<a<<' '<<b;}
};

void main()
{
cout<<endl<<"class D";          D d;
cout<<endl<<"class D(int)";     D di(5);
cout<<endl<<"class DV";         DV dv;
cout<<endl<<"class DV(int)";    DV dvi(5);
}
